require 'yaml'

module WasabiSwagger
  class GenerateDocumentation
    def self.call(url, request_type, options)
      new(url, request_type, options).call
    end

    def call
      result_hash = transform_hash
      puts result_hash.to_yaml
      File.open('test.yaml', 'w') do |file|
        file.write(result_hash.to_yaml)
      end
    end

    private

    attr_accessor :options, :url, :request_type

    def initialize(url, request_type, options = {})
      @url = url
      @request_type = request_type
      list_of_options(options)
    end

    def list_of_options(options)
      @options = Hash.new('Input here')
      @options['operationId'] = options[:operationId]
      @options['tags'] = options[:tags]
      @options['consumes'] = options[:consumes]
      @options['produces'] = options[:produces]
      @options['summary'] = options[:summary]
      @options['description'] = options[:description]
    end

    def transform_hash
      result = {}
      data_for_request = {}
      data_for_request[@request_type] = @options
      result[@url] = data_for_request
      result
    end
  end
end
